#!/bin/bash

ROOT=initrd_root
BIN=bin

rm -rf $ROOT

mkdir -p $ROOT/mnt
mkdir -p $ROOT/dev
mkdir -p $ROOT/proc

cp $BIN/init $ROOT
cp pkbd.ko $ROOT

sudo mknod $ROOT/dev/sdb b 8 16
sudo mknod $ROOT/dev/sdb1 b 8 17

cd $ROOT && find | cpio -H newc -o | gzip -9 -n > ../initrd.cpio.gz
