.global _start
.type _start, @function	
_start:
	call insmod

	/* switch_root */
	/* mount /dev/sdb1 /mnt */
	mov $165, %rax
	mov $dev, %rdi
	mov $mnt, %rsi
	mov $fstype, %rdx
	mov $0xc0ed0000, %r10
	mov $0, %r8

	syscall

	/* chdir /mnt */
	mov $80, %rax
	mov $mnt, %rdi
	syscall

	/* mount --move . / */
	mov $165, %rax
	mov $dot, %rdi
	mov $root, %rsi
	mov $fstype, %rdx
	mov $0x2000, %r10
	mov $0, %r8

	syscall

	/* chroot . */
	mov $161, %rax
	mov $dot, %rdi
	syscall

	/* close(0) */
	mov $3, %rax
	mov $0, %rdi
	syscall

	/* open /dev/console */
	mov $2, %rax
	mov $console, %rdi
	mov $2, %rsi
	mov $0, %rdx
	syscall

	/* dup2(0, 1), dup2(0, 2) */
	mov $33, %rax
	mov $0, %rdi
	mov $1, %rsi
	syscall
	mov $33, %rax
	mov $0, %rdi
	mov $2, %rsi
	syscall

	/* execve /sbin/init */
	mov $59, %rax
	mov $sbininit, %rdi
	mov $argv, %rsi
	mov $0, %rdx
	syscall

	/* exit if failed */
	mov $60, %rax
	mov $0, %rdi

	syscall
	

.type insmod, @function
insmod:
	sub $16384, %rsp

	/* open module file */
	mov $2, %rax
	mov $modpath, %rdi
	mov $0, %rsi
	mov $0, %rdx
	syscall

	cmp $0, %rax

	push %rax
	
	/* read content */
	lea 8(%rsp), %rsi
	xor %rcx, %rcx
read_loop:
	push %rsi
	push %rcx

	mov $0, %rax
	mov 16(%rsp), %rdi
	mov $4096, %rdx
	syscall

	pop %rcx

	cmp $0, %rax
	je done

	add %rax, %rcx	
	pop %rsi
	add %rax, %rsi
	jmp read_loop

done:
	add %rax, %rcx
	
	pop %rsi

	/* init_module */
	mov %rcx, %rsi
	mov $175, %rax
	lea 8(%rsp), %rdi
	mov $emptystr, %rdx
	syscall

	cmp $0, %rax

	/* close */
	pop %rdi
	mov $3, %rax
	syscall

	add $16384, %rsp

	retq

dev:
	.asciz "/dev/sdb1"
root:
	.asciz "/"
mnt:
	.asciz "/mnt"
fstype:
	.asciz "ext4"
sbininit:
	.asciz "/sbin/init"
init:
	.asciz "init"
dot:
	.asciz "."
emptystr:
	.asciz ""
argv:
	.quad sbininit
	.quad init
	.quad 0
modpath:
	.asciz "/pkbd.ko"
console:
	.asciz "/dev/console"
